{"templateId":"markdown","sharedDataIds":{"sidebar":"sidebar-sidebars.yaml"},"props":{"metadata":{"markdoc":{"tagList":[]},"type":"markdown"},"seo":{"title":"Cloud Phone File Upload and Download"},"dynamicMarkdocComponents":[],"compilationErrors":[],"ast":{"$$mdtype":"Tag","name":"article","attributes":{},"children":[{"$$mdtype":"Tag","name":"Heading","attributes":{"level":1,"id":"cloud-phone-file-upload-and-download","__idx":0},"children":["Cloud Phone File Upload and Download"]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["This guide shows the complete file-transfer workflow: upload a local file to a Cloud Phone, export a file from the Cloud Phone, poll asynchronous tasks, and recover safely from timeouts."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":2,"id":"choose-an-api-surface","__idx":1},"children":["Choose an API surface"]},{"$$mdtype":"Tag","name":"div","attributes":{"className":"md-table-wrapper"},"children":[{"$$mdtype":"Tag","name":"table","attributes":{"className":"md"},"children":[{"$$mdtype":"Tag","name":"thead","attributes":{},"children":[{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"Step"},"children":["Step"]},{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"Open API"},"children":["Open API"]},{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"Local API"},"children":["Local API"]}]}]},{"$$mdtype":"Tag","name":"tbody","attributes":{},"children":[{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Base URL"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["https://api.morelogin.com"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["http://127.0.0.1:40000"]}]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Authentication"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["Authorization: Bearer <token>"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Local API token when enabled"]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Request upload URL"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /cloudphone/uploadUrl"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/upload/file/signedUrl"]}]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Register uploaded object"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /cloudphone/uploadFile"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/upload/file"]}]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Query upload result"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /cloudphone/uploadFileResult"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/upload/file/result"]}]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Request file export"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /cloudphone/download"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/download"]}]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Query export result"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /cloudphone/download/result"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/download/result"]}]}]}]}]}]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["The examples below use Open API. To use Local API, change the base URL and paths according to the table. Keep Cloud Phone IDs and task IDs as strings; JavaScript clients must not convert them through ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["Number"]},"."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":3,"id":"local-api-multipart-shortcut","__idx":2},"children":["Local API multipart shortcut"]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["When the file is on the same machine as the MoreLogin client, Local API also provides ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["POST /api/cloudphone/uploadFile"]}," with ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["multipart/form-data"]},":"]},{"$$mdtype":"Tag","name":"CodeBlock","attributes":{"data-language":"bash","header":{"controls":{"copy":{}}},"source":"curl --request POST \"http://127.0.0.1:40000/api/cloudphone/uploadFile\" \\\n  --form 'id=1661515884160372' \\\n  --form 'uploadDest=/Download' \\\n  --form 'file=@./report.csv'\n","lang":"bash"},"children":[]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Use the signed-URL workflow below when the caller runs remotely, when the file is large, or when you need a ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["fileId"]}," for explicit status polling."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":2,"id":"upload-workflow","__idx":3},"children":["Upload workflow"]},{"$$mdtype":"Tag","name":"Diagram","attributes":{"data-language":"mermaid","diagramType":"mermaid","diagramSource":"sequenceDiagram\n    participant Client\n    participant API as MoreLogin API\n    participant Storage as Temporary storage\n    participant Phone as Cloud Phone\n    Client->>API: 1. Request pre-signed URL\n    API-->>Client: presignedUrl\n    Client->>Storage: 2. PUT file bytes\n    Storage-->>Client: 2xx\n    Client->>API: 3. Register object URL\n    API-->>Client: fileId, status=0\n    loop Until terminal status\n        Client->>API: 4. Query upload result\n        API-->>Client: null / status 0, 1, or 2\n    end\n    API->>Phone: Deliver file\n","diagramHtml":"<svg id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7\" width=\"100%\" xmlns=\"http://www.w3.org/2000/svg\" style=\"max-width: 917px;\" viewBox=\"-50 -10 917 632\" role=\"graphics-document document\" aria-roledescription=\"sequence\"><style>\n    #diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 foreignObject {\n      overflow: visible;\n    }\n  </style><g><rect x=\"667\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"742\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"742\" dy=\"0\">Cloud Phone</tspan></text></g><g><rect x=\"464\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"540.5\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"540.5\" dy=\"0\">Temporary storage</tspan></text></g><g><rect x=\"264\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"339\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"339\" dy=\"0\">MoreLogin API</tspan></text></g><g><rect x=\"0\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"75\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g><g><line id=\"actor3\" x1=\"742\" y1=\"65\" x2=\"742\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Phone\" data-et=\"life-line\" data-id=\"Phone\"></line><g id=\"root-3\" data-et=\"participant\" data-type=\"participant\" data-id=\"Phone\"><rect x=\"667\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"742\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"742\" dy=\"0\">Cloud Phone</tspan></text></g></g><g><line id=\"actor2\" x1=\"540.5\" y1=\"65\" x2=\"540.5\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Storage\" data-et=\"life-line\" data-id=\"Storage\"></line><g id=\"root-2\" data-et=\"participant\" data-type=\"participant\" data-id=\"Storage\"><rect x=\"464\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"540.5\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"540.5\" dy=\"0\">Temporary storage</tspan></text></g></g><g><line id=\"actor1\" x1=\"339\" y1=\"65\" x2=\"339\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"API\" data-et=\"life-line\" data-id=\"API\"></line><g id=\"root-1\" data-et=\"participant\" data-type=\"participant\" data-id=\"API\"><rect x=\"264\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"339\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"339\" dy=\"0\">MoreLogin API</tspan></text></g></g><g><line id=\"actor0\" x1=\"75\" y1=\"65\" x2=\"75\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Client\" data-et=\"life-line\" data-id=\"Client\"></line><g id=\"root-0\" data-et=\"participant\" data-type=\"participant\" data-id=\"Client\"><rect x=\"0\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"75\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g></g><style>#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;fill:#333;}@keyframes edge-animation-frame{from{stroke-dashoffset:0;}}@keyframes dash{to{stroke-dashoffset:0;}}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-animation-slow{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 50s linear infinite;stroke-linecap:round;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-animation-fast{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 20s linear infinite;stroke-linecap:round;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .error-icon{fill:#552222;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .error-text{fill:#552222;stroke:#552222;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-thickness-normal{stroke-width:1px;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-thickness-thick{stroke-width:3.5px;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-pattern-solid{stroke-dasharray:0;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-thickness-invisible{stroke-width:0;fill:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-pattern-dashed{stroke-dasharray:3;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .edge-pattern-dotted{stroke-dasharray:2;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .marker{fill:#333333;stroke:#333333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .marker.cross{stroke:#333333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 svg{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 p{margin:0;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .actor{stroke:#9370DB;fill:#ECECFF;stroke-width:1;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 rect.actor.outer-path[data-look=\"neo\"]{filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 rect.note[data-look=\"neo\"]{stroke:#aaaa33;fill:#fff5ad;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 text.actor&gt;tspan{fill:black;stroke:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .actor-line{stroke:#9370DB;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .innerArc{stroke-width:1.5;stroke-dasharray:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .messageLine0{stroke-width:1.5;stroke-dasharray:none;stroke:#333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .messageLine1{stroke-width:1.5;stroke-dasharray:2,2;stroke:#333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [id$=\"-arrowhead\"] path{fill:#333;stroke:#333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .sequenceNumber{fill:white;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [id$=\"-sequencenumber\"]{fill:#333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [id$=\"-crosshead\"] path{fill:#333;stroke:#333;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .messageText{fill:#333;stroke:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .labelBox{stroke:#9370DB;fill:#ECECFF;filter:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .labelText,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .labelText&gt;tspan{fill:black;stroke:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .loopText,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .loopText&gt;tspan{fill:black;stroke:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .sectionTitle,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .sectionTitle&gt;tspan{fill:black;stroke:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .loopLine{stroke-width:2px;stroke-dasharray:2,2;stroke:#9370DB;fill:#9370DB;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .note{stroke:#aaaa33;fill:#fff5ad;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .noteText,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .noteText&gt;tspan{fill:black;stroke:none;font-weight:normal;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .activation0{fill:#f4f4f4;stroke:#666;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .activation1{fill:#f4f4f4;stroke:#666;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .activation2{fill:#f4f4f4;stroke:#666;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .actorPopupMenu{position:absolute;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .actorPopupMenuPanel{position:absolute;fill:#ECECFF;box-shadow:0px 8px 16px 0px rgba(0,0,0,0.2);filter:drop-shadow(3px 5px 2px rgb(0 0 0 / 0.4));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .actor-man circle,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 line{fill:#ECECFF;stroke-width:2px;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 g rect.rect{filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));stroke:#9370DB;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 .node .neo-node{stroke:#9370DB;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node rect,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].cluster rect,#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node polygon{stroke:#9370DB;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].swimlane.cluster rect{filter:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node path{stroke:#9370DB;stroke-width:1px;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node .outer-path{filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node .neo-line path{stroke:#9370DB;filter:none;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node circle{stroke:#9370DB;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].node circle .state-start{fill:#000000;}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].icon-shape .icon{fill:#9370DB;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 [data-look=\"neo\"].icon-shape .icon-neo path{stroke:#9370DB;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7 :root{--mermaid-font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;}</style><g></g><defs><symbol id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-computer\" width=\"24\" height=\"24\"><path transform=\"scale(.5)\" d=\"M2 2v13h20v-13h-20zm18 11h-16v-9h16v9zm-10.228 6l.466-1h3.524l.467 1h-4.457zm14.228 3h-24l2-6h2.104l-1.33 4h18.45l-1.297-4h2.073l2 6zm-5-10h-14v-7h14v7z\"></path></symbol></defs><defs><symbol id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-database\" fill-rule=\"evenodd\" clip-rule=\"evenodd\"><path transform=\"scale(.5)\" d=\"M12.258.001l.256.004.255.005.253.008.251.01.249.012.247.015.246.016.242.019.241.02.239.023.236.024.233.027.231.028.229.031.225.032.223.034.22.036.217.038.214.04.211.041.208.043.205.045.201.046.198.048.194.05.191.051.187.053.183.054.18.056.175.057.172.059.168.06.163.061.16.063.155.064.15.066.074.033.073.033.071.034.07.034.069.035.068.035.067.035.066.035.064.036.064.036.062.036.06.036.06.037.058.037.058.037.055.038.055.038.053.038.052.038.051.039.05.039.048.039.047.039.045.04.044.04.043.04.041.04.04.041.039.041.037.041.036.041.034.041.033.042.032.042.03.042.029.042.027.042.026.043.024.043.023.043.021.043.02.043.018.044.017.043.015.044.013.044.012.044.011.045.009.044.007.045.006.045.004.045.002.045.001.045v17l-.001.045-.002.045-.004.045-.006.045-.007.045-.009.044-.011.045-.012.044-.013.044-.015.044-.017.043-.018.044-.02.043-.021.043-.023.043-.024.043-.026.043-.027.042-.029.042-.03.042-.032.042-.033.042-.034.041-.036.041-.037.041-.039.041-.04.041-.041.04-.043.04-.044.04-.045.04-.047.039-.048.039-.05.039-.051.039-.052.038-.053.038-.055.038-.055.038-.058.037-.058.037-.06.037-.06.036-.062.036-.064.036-.064.036-.066.035-.067.035-.068.035-.069.035-.07.034-.071.034-.073.033-.074.033-.15.066-.155.064-.16.063-.163.061-.168.06-.172.059-.175.057-.18.056-.183.054-.187.053-.191.051-.194.05-.198.048-.201.046-.205.045-.208.043-.211.041-.214.04-.217.038-.22.036-.223.034-.225.032-.229.031-.231.028-.233.027-.236.024-.239.023-.241.02-.242.019-.246.016-.247.015-.249.012-.251.01-.253.008-.255.005-.256.004-.258.001-.258-.001-.256-.004-.255-.005-.253-.008-.251-.01-.249-.012-.247-.015-.245-.016-.243-.019-.241-.02-.238-.023-.236-.024-.234-.027-.231-.028-.228-.031-.226-.032-.223-.034-.22-.036-.217-.038-.214-.04-.211-.041-.208-.043-.204-.045-.201-.046-.198-.048-.195-.05-.19-.051-.187-.053-.184-.054-.179-.056-.176-.057-.172-.059-.167-.06-.164-.061-.159-.063-.155-.064-.151-.066-.074-.033-.072-.033-.072-.034-.07-.034-.069-.035-.068-.035-.067-.035-.066-.035-.064-.036-.063-.036-.062-.036-.061-.036-.06-.037-.058-.037-.057-.037-.056-.038-.055-.038-.053-.038-.052-.038-.051-.039-.049-.039-.049-.039-.046-.039-.046-.04-.044-.04-.043-.04-.041-.04-.04-.041-.039-.041-.037-.041-.036-.041-.034-.041-.033-.042-.032-.042-.03-.042-.029-.042-.027-.042-.026-.043-.024-.043-.023-.043-.021-.043-.02-.043-.018-.044-.017-.043-.015-.044-.013-.044-.012-.044-.011-.045-.009-.044-.007-.045-.006-.045-.004-.045-.002-.045-.001-.045v-17l.001-.045.002-.045.004-.045.006-.045.007-.045.009-.044.011-.045.012-.044.013-.044.015-.044.017-.043.018-.044.02-.043.021-.043.023-.043.024-.043.026-.043.027-.042.029-.042.03-.042.032-.042.033-.042.034-.041.036-.041.037-.041.039-.041.04-.041.041-.04.043-.04.044-.04.046-.04.046-.039.049-.039.049-.039.051-.039.052-.038.053-.038.055-.038.056-.038.057-.037.058-.037.06-.037.061-.036.062-.036.063-.036.064-.036.066-.035.067-.035.068-.035.069-.035.07-.034.072-.034.072-.033.074-.033.151-.066.155-.064.159-.063.164-.061.167-.06.172-.059.176-.057.179-.056.184-.054.187-.053.19-.051.195-.05.198-.048.201-.046.204-.045.208-.043.211-.041.214-.04.217-.038.22-.036.223-.034.226-.032.228-.031.231-.028.234-.027.236-.024.238-.023.241-.02.243-.019.245-.016.247-.015.249-.012.251-.01.253-.008.255-.005.256-.004.258-.001.258.001zm-9.258 20.499v.01l.001.021.003.021.004.022.005.021.006.022.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.023.018.024.019.024.021.024.022.025.023.024.024.025.052.049.056.05.061.051.066.051.07.051.075.051.079.052.084.052.088.052.092.052.097.052.102.051.105.052.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.048.144.049.147.047.152.047.155.047.16.045.163.045.167.043.171.043.176.041.178.041.183.039.187.039.19.037.194.035.197.035.202.033.204.031.209.03.212.029.216.027.219.025.222.024.226.021.23.02.233.018.236.016.24.015.243.012.246.01.249.008.253.005.256.004.259.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.021.224-.024.22-.026.216-.027.212-.028.21-.031.205-.031.202-.034.198-.034.194-.036.191-.037.187-.039.183-.04.179-.04.175-.042.172-.043.168-.044.163-.045.16-.046.155-.046.152-.047.148-.048.143-.049.139-.049.136-.05.131-.05.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.053.083-.051.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.05.023-.024.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.023.01-.022.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.127l-.077.055-.08.053-.083.054-.085.053-.087.052-.09.052-.093.051-.095.05-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.045-.118.044-.12.043-.122.042-.124.042-.126.041-.128.04-.13.04-.132.038-.134.038-.135.037-.138.037-.139.035-.142.035-.143.034-.144.033-.147.032-.148.031-.15.03-.151.03-.153.029-.154.027-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.01-.179.008-.179.008-.181.006-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.006-.179-.008-.179-.008-.178-.01-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.027-.153-.029-.151-.03-.15-.03-.148-.031-.146-.032-.145-.033-.143-.034-.141-.035-.14-.035-.137-.037-.136-.037-.134-.038-.132-.038-.13-.04-.128-.04-.126-.041-.124-.042-.122-.042-.12-.044-.117-.043-.116-.045-.113-.045-.112-.046-.109-.047-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.05-.093-.052-.09-.051-.087-.052-.085-.053-.083-.054-.08-.054-.077-.054v4.127zm0-5.654v.011l.001.021.003.021.004.021.005.022.006.022.007.022.009.022.01.022.011.023.012.023.013.023.015.024.016.023.017.024.018.024.019.024.021.024.022.024.023.025.024.024.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.052.11.051.114.051.119.052.123.05.127.051.131.05.135.049.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.044.171.042.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.022.23.02.233.018.236.016.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.012.241-.015.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.048.139-.05.136-.049.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.051.051-.049.023-.025.023-.024.021-.025.02-.024.019-.024.018-.024.017-.024.015-.023.014-.023.013-.024.012-.022.01-.023.01-.023.008-.022.006-.022.006-.022.004-.021.004-.022.001-.021.001-.021v-4.139l-.077.054-.08.054-.083.054-.085.052-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.044-.118.044-.12.044-.122.042-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.035-.143.033-.144.033-.147.033-.148.031-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.009-.179.009-.179.007-.181.007-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.007-.179-.007-.179-.009-.178-.009-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.031-.146-.033-.145-.033-.143-.033-.141-.035-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.04-.126-.041-.124-.042-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.051-.093-.051-.09-.051-.087-.053-.085-.052-.083-.054-.08-.054-.077-.054v4.139zm0-5.666v.011l.001.02.003.022.004.021.005.022.006.021.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.024.018.023.019.024.021.025.022.024.023.024.024.025.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.051.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.043.171.043.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.021.23.02.233.018.236.017.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.013.241-.014.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.049.139-.049.136-.049.131-.051.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.049.023-.025.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.022.01-.023.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.153l-.077.054-.08.054-.083.053-.085.053-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.048-.105.048-.106.048-.109.046-.111.046-.114.046-.115.044-.118.044-.12.043-.122.043-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.034-.143.034-.144.033-.147.032-.148.032-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.024-.161.024-.162.023-.163.023-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.01-.178.01-.179.009-.179.007-.181.006-.182.006-.182.004-.184.003-.184.001-.185.001-.185-.001-.184-.001-.184-.003-.182-.004-.182-.006-.181-.006-.179-.007-.179-.009-.178-.01-.176-.01-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.023-.162-.023-.161-.024-.159-.024-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.032-.146-.032-.145-.033-.143-.034-.141-.034-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.041-.126-.041-.124-.041-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.048-.105-.048-.102-.048-.1-.05-.097-.049-.095-.051-.093-.051-.09-.052-.087-.052-.085-.053-.083-.053-.08-.054-.077-.054v4.153zm8.74-8.179l-.257.004-.254.005-.25.008-.247.011-.244.012-.241.014-.237.016-.233.018-.231.021-.226.022-.224.023-.22.026-.216.027-.212.028-.21.031-.205.032-.202.033-.198.034-.194.036-.191.038-.187.038-.183.04-.179.041-.175.042-.172.043-.168.043-.163.045-.16.046-.155.046-.152.048-.148.048-.143.048-.139.049-.136.05-.131.05-.126.051-.123.051-.118.051-.114.052-.11.052-.106.052-.101.052-.096.052-.092.052-.088.052-.083.052-.079.052-.074.051-.07.052-.065.051-.06.05-.056.05-.051.05-.023.025-.023.024-.021.024-.02.025-.019.024-.018.024-.017.023-.015.024-.014.023-.013.023-.012.023-.01.023-.01.022-.008.022-.006.023-.006.021-.004.022-.004.021-.001.021-.001.021.001.021.001.021.004.021.004.022.006.021.006.023.008.022.01.022.01.023.012.023.013.023.014.023.015.024.017.023.018.024.019.024.02.025.021.024.023.024.023.025.051.05.056.05.06.05.065.051.07.052.074.051.079.052.083.052.088.052.092.052.096.052.101.052.106.052.11.052.114.052.118.051.123.051.126.051.131.05.136.05.139.049.143.048.148.048.152.048.155.046.16.046.163.045.168.043.172.043.175.042.179.041.183.04.187.038.191.038.194.036.198.034.202.033.205.032.21.031.212.028.216.027.22.026.224.023.226.022.231.021.233.018.237.016.241.014.244.012.247.011.25.008.254.005.257.004.26.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.022.224-.023.22-.026.216-.027.212-.028.21-.031.205-.032.202-.033.198-.034.194-.036.191-.038.187-.038.183-.04.179-.041.175-.042.172-.043.168-.043.163-.045.16-.046.155-.046.152-.048.148-.048.143-.048.139-.049.136-.05.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.05.051-.05.023-.025.023-.024.021-.024.02-.025.019-.024.018-.024.017-.023.015-.024.014-.023.013-.023.012-.023.01-.023.01-.022.008-.022.006-.023.006-.021.004-.022.004-.021.001-.021.001-.021-.001-.021-.001-.021-.004-.021-.004-.022-.006-.021-.006-.023-.008-.022-.01-.022-.01-.023-.012-.023-.013-.023-.014-.023-.015-.024-.017-.023-.018-.024-.019-.024-.02-.025-.021-.024-.023-.024-.023-.025-.051-.05-.056-.05-.06-.05-.065-.051-.07-.052-.074-.051-.079-.052-.083-.052-.088-.052-.092-.052-.096-.052-.101-.052-.106-.052-.11-.052-.114-.052-.118-.051-.123-.051-.126-.051-.131-.05-.136-.05-.139-.049-.143-.048-.148-.048-.152-.048-.155-.046-.16-.046-.163-.045-.168-.043-.172-.043-.175-.042-.179-.041-.183-.04-.187-.038-.191-.038-.194-.036-.198-.034-.202-.033-.205-.032-.21-.031-.212-.028-.216-.027-.22-.026-.224-.023-.226-.022-.231-.021-.233-.018-.237-.016-.241-.014-.244-.012-.247-.011-.25-.008-.254-.005-.257-.004-.26-.001-.26.001z\"></path></symbol></defs><defs><symbol id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-clock\" width=\"24\" height=\"24\"><path transform=\"scale(.5)\" d=\"M12 2c5.514 0 10 4.486 10 10s-4.486 10-10 10-10-4.486-10-10 4.486-10 10-10zm0-2c-6.627 0-12 5.373-12 12s5.373 12 12 12 12-5.373 12-12-5.373-12-12-12zm5.848 12.459c.202.038.202.333.001.372-1.907.361-6.045 1.111-6.547 1.111-.719 0-1.301-.582-1.301-1.301 0-.512.77-5.447 1.125-7.445.034-.192.312-.181.343.014l.985 6.238 5.394 1.011z\"></path></symbol></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead\" refX=\"7.9\" refY=\"5\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M -1 0 L 10 5 L 0 10 z\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-crosshead\" markerWidth=\"15\" markerHeight=\"8\" orient=\"auto\" refX=\"4\" refY=\"4.5\"><path fill=\"none\" stroke=\"#000000\" stroke-width=\"1pt\" d=\"M 1,2 L 6,7 M 6,2 L 1,7\" style=\"stroke-dasharray: 0, 0;\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-filled-head\" refX=\"15.5\" refY=\"7\" markerWidth=\"20\" markerHeight=\"28\" orient=\"auto\"><path d=\"M 18,7 L9,13 L14,7 L9,1 Z\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-sequencenumber\" refX=\"15\" refY=\"15\" markerWidth=\"60\" markerHeight=\"40\" orient=\"auto\"><circle cx=\"15\" cy=\"15\" r=\"6\"></circle></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-solidTopArrowHead\" refX=\"7.9\" refY=\"7.25\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 10 8 L 0 8 z\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-solidBottomArrowHead\" refX=\"7.9\" refY=\"0.75\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 10 0 L 0 8 z\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-stickTopArrowHead\" refX=\"7.5\" refY=\"7\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 7 7\" stroke=\"black\" stroke-width=\"1.5\" fill=\"none\"></path></marker></defs><defs><marker id=\"diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-stickBottomArrowHead\" refX=\"7.5\" refY=\"0\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 7 L 7 0\" stroke=\"black\" stroke-width=\"1.5\" fill=\"none\"></path></marker></defs><g data-et=\"control-structure\" data-id=\"i9\"><line x1=\"64\" y1=\"347\" x2=\"350\" y2=\"347\" class=\"loopLine\"></line><line x1=\"350\" y1=\"347\" x2=\"350\" y2=\"482\" class=\"loopLine\"></line><line x1=\"64\" y1=\"482\" x2=\"350\" y2=\"482\" class=\"loopLine\"></line><line x1=\"64\" y1=\"347\" x2=\"64\" y2=\"482\" class=\"loopLine\"></line><polygon points=\"64,347 114,347 114,360 105.6,367 64,367\" class=\"labelBox\"></polygon><text x=\"89\" y=\"360\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"labelText\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">loop</text><text x=\"232\" y=\"365\" text-anchor=\"middle\" class=\"loopText\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\"><tspan x=\"232\">[Until terminal status]</tspan></text></g><text x=\"206\" y=\"80\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">1. Request pre-signed URL</text><line x1=\"76\" y1=\"111\" x2=\"335\" y2=\"111\" class=\"messageLine0\" data-et=\"message\" data-id=\"i0\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"126\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">presignedUrl</text><line x1=\"338\" y1=\"157\" x2=\"79\" y2=\"157\" class=\"messageLine1\" data-et=\"message\" data-id=\"i1\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"306\" y=\"172\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">2. PUT file bytes</text><line x1=\"76\" y1=\"203\" x2=\"536.5\" y2=\"203\" class=\"messageLine0\" data-et=\"message\" data-id=\"i2\" data-from=\"Client\" data-to=\"Storage\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"fill: none;\"></line><text x=\"309\" y=\"218\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">2xx</text><line x1=\"539.5\" y1=\"247\" x2=\"79\" y2=\"247\" class=\"messageLine1\" data-et=\"message\" data-id=\"i3\" data-from=\"Storage\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"206\" y=\"262\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">3. Register object URL</text><line x1=\"76\" y1=\"293\" x2=\"335\" y2=\"293\" class=\"messageLine0\" data-et=\"message\" data-id=\"i4\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"308\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">fileId, status=0</text><line x1=\"338\" y1=\"337\" x2=\"79\" y2=\"337\" class=\"messageLine1\" data-et=\"message\" data-id=\"i5\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"206\" y=\"397\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">4. Query upload result</text><line x1=\"76\" y1=\"428\" x2=\"335\" y2=\"428\" class=\"messageLine0\" data-et=\"message\" data-id=\"i7\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"443\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">null / status 0, 1, or 2</text><line x1=\"338\" y1=\"472\" x2=\"79\" y2=\"472\" class=\"messageLine1\" data-et=\"message\" data-id=\"i8\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"539\" y=\"497\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">Deliver file</text><line x1=\"340\" y1=\"526\" x2=\"738\" y2=\"526\" class=\"messageLine0\" data-et=\"message\" data-id=\"i10\" data-from=\"API\" data-to=\"Phone\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-3ca2da962e37b80b1d2b89e725cbec3e7374fc5b2ae575be9bf4bb1c8938a2a7-arrowhead)\" style=\"fill: none;\"></line></svg>","diagramHtmlDark":"<svg id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e\" width=\"100%\" xmlns=\"http://www.w3.org/2000/svg\" style=\"max-width: 917px;\" viewBox=\"-50 -10 917 632\" role=\"graphics-document document\" aria-roledescription=\"sequence\"><style>\n    #diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e foreignObject {\n      overflow: visible;\n    }\n  </style><g><rect x=\"667\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"742\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"742\" dy=\"0\">Cloud Phone</tspan></text></g><g><rect x=\"464\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"540.5\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"540.5\" dy=\"0\">Temporary storage</tspan></text></g><g><rect x=\"264\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"339\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"339\" dy=\"0\">MoreLogin API</tspan></text></g><g><rect x=\"0\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"75\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g><g><line id=\"actor3\" x1=\"742\" y1=\"65\" x2=\"742\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Phone\" data-et=\"life-line\" data-id=\"Phone\"></line><g id=\"root-3\" data-et=\"participant\" data-type=\"participant\" data-id=\"Phone\"><rect x=\"667\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"742\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"742\" dy=\"0\">Cloud Phone</tspan></text></g></g><g><line id=\"actor2\" x1=\"540.5\" y1=\"65\" x2=\"540.5\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Storage\" data-et=\"life-line\" data-id=\"Storage\"></line><g id=\"root-2\" data-et=\"participant\" data-type=\"participant\" data-id=\"Storage\"><rect x=\"464\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"540.5\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"540.5\" dy=\"0\">Temporary storage</tspan></text></g></g><g><line id=\"actor1\" x1=\"339\" y1=\"65\" x2=\"339\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"API\" data-et=\"life-line\" data-id=\"API\"></line><g id=\"root-1\" data-et=\"participant\" data-type=\"participant\" data-id=\"API\"><rect x=\"264\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"339\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"339\" dy=\"0\">MoreLogin API</tspan></text></g></g><g><line id=\"actor0\" x1=\"75\" y1=\"65\" x2=\"75\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Client\" data-et=\"life-line\" data-id=\"Client\"></line><g id=\"root-0\" data-et=\"participant\" data-type=\"participant\" data-id=\"Client\"><rect x=\"0\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"75\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g></g><style>#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;fill:#ccc;}@keyframes edge-animation-frame{from{stroke-dashoffset:0;}}@keyframes dash{to{stroke-dashoffset:0;}}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-animation-slow{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 50s linear infinite;stroke-linecap:round;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-animation-fast{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 20s linear infinite;stroke-linecap:round;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .error-icon{fill:#a44141;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .error-text{fill:#ddd;stroke:#ddd;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-thickness-normal{stroke-width:1px;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-thickness-thick{stroke-width:3.5px;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-pattern-solid{stroke-dasharray:0;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-thickness-invisible{stroke-width:0;fill:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-pattern-dashed{stroke-dasharray:3;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .edge-pattern-dotted{stroke-dasharray:2;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .marker{fill:lightgrey;stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .marker.cross{stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e svg{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e p{margin:0;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .actor{stroke:#ccc;fill:#1f2020;stroke-width:1;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e rect.actor.outer-path[data-look=\"neo\"]{filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e rect.note[data-look=\"neo\"]{stroke:hsl(180, 0%, 18.3529411765%);fill:hsl(180, 1.5873015873%, 28.3529411765%);filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e text.actor&gt;tspan{fill:lightgrey;stroke:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .actor-line{stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .innerArc{stroke-width:1.5;stroke-dasharray:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .messageLine0{stroke-width:1.5;stroke-dasharray:none;stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .messageLine1{stroke-width:1.5;stroke-dasharray:2,2;stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [id$=\"-arrowhead\"] path{fill:lightgrey;stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .sequenceNumber{fill:black;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [id$=\"-sequencenumber\"]{fill:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [id$=\"-crosshead\"] path{fill:lightgrey;stroke:lightgrey;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .messageText{fill:lightgrey;stroke:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .labelBox{stroke:#ccc;fill:#1f2020;filter:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .labelText,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .labelText&gt;tspan{fill:lightgrey;stroke:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .loopText,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .loopText&gt;tspan{fill:lightgrey;stroke:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .sectionTitle,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .sectionTitle&gt;tspan{fill:lightgrey;stroke:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .loopLine{stroke-width:2px;stroke-dasharray:2,2;stroke:#ccc;fill:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .note{stroke:hsl(180, 0%, 18.3529411765%);fill:hsl(180, 1.5873015873%, 28.3529411765%);}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .noteText,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .noteText&gt;tspan{fill:rgb(183.8476190475, 181.5523809523, 181.5523809523);stroke:none;font-weight:normal;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .activation0{fill:hsl(180, 1.5873015873%, 28.3529411765%);stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .activation1{fill:hsl(180, 1.5873015873%, 28.3529411765%);stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .activation2{fill:hsl(180, 1.5873015873%, 28.3529411765%);stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .actorPopupMenu{position:absolute;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .actorPopupMenuPanel{position:absolute;fill:#1f2020;box-shadow:0px 8px 16px 0px rgba(0,0,0,0.2);filter:drop-shadow(3px 5px 2px rgb(0 0 0 / 0.4));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .actor-man circle,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e line{fill:#1f2020;stroke-width:2px;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e g rect.rect{filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e .node .neo-node{stroke:#ccc;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node rect,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].cluster rect,#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node polygon{stroke:url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-gradient);filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].swimlane.cluster rect{filter:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node path{stroke:url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-gradient);stroke-width:1px;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node .outer-path{filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node .neo-line path{stroke:#ccc;filter:none;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node circle{stroke:url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-gradient);filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].node circle .state-start{fill:#000000;}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].icon-shape .icon{fill:url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-gradient);filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e [data-look=\"neo\"].icon-shape .icon-neo path{stroke:url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-gradient);filter:drop-shadow( 1px 2px 2px rgba(185,185,185,1));}#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e :root{--mermaid-font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;}</style><g></g><defs><symbol id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-computer\" width=\"24\" height=\"24\"><path transform=\"scale(.5)\" d=\"M2 2v13h20v-13h-20zm18 11h-16v-9h16v9zm-10.228 6l.466-1h3.524l.467 1h-4.457zm14.228 3h-24l2-6h2.104l-1.33 4h18.45l-1.297-4h2.073l2 6zm-5-10h-14v-7h14v7z\"></path></symbol></defs><defs><symbol id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-database\" fill-rule=\"evenodd\" clip-rule=\"evenodd\"><path transform=\"scale(.5)\" d=\"M12.258.001l.256.004.255.005.253.008.251.01.249.012.247.015.246.016.242.019.241.02.239.023.236.024.233.027.231.028.229.031.225.032.223.034.22.036.217.038.214.04.211.041.208.043.205.045.201.046.198.048.194.05.191.051.187.053.183.054.18.056.175.057.172.059.168.06.163.061.16.063.155.064.15.066.074.033.073.033.071.034.07.034.069.035.068.035.067.035.066.035.064.036.064.036.062.036.06.036.06.037.058.037.058.037.055.038.055.038.053.038.052.038.051.039.05.039.048.039.047.039.045.04.044.04.043.04.041.04.04.041.039.041.037.041.036.041.034.041.033.042.032.042.03.042.029.042.027.042.026.043.024.043.023.043.021.043.02.043.018.044.017.043.015.044.013.044.012.044.011.045.009.044.007.045.006.045.004.045.002.045.001.045v17l-.001.045-.002.045-.004.045-.006.045-.007.045-.009.044-.011.045-.012.044-.013.044-.015.044-.017.043-.018.044-.02.043-.021.043-.023.043-.024.043-.026.043-.027.042-.029.042-.03.042-.032.042-.033.042-.034.041-.036.041-.037.041-.039.041-.04.041-.041.04-.043.04-.044.04-.045.04-.047.039-.048.039-.05.039-.051.039-.052.038-.053.038-.055.038-.055.038-.058.037-.058.037-.06.037-.06.036-.062.036-.064.036-.064.036-.066.035-.067.035-.068.035-.069.035-.07.034-.071.034-.073.033-.074.033-.15.066-.155.064-.16.063-.163.061-.168.06-.172.059-.175.057-.18.056-.183.054-.187.053-.191.051-.194.05-.198.048-.201.046-.205.045-.208.043-.211.041-.214.04-.217.038-.22.036-.223.034-.225.032-.229.031-.231.028-.233.027-.236.024-.239.023-.241.02-.242.019-.246.016-.247.015-.249.012-.251.01-.253.008-.255.005-.256.004-.258.001-.258-.001-.256-.004-.255-.005-.253-.008-.251-.01-.249-.012-.247-.015-.245-.016-.243-.019-.241-.02-.238-.023-.236-.024-.234-.027-.231-.028-.228-.031-.226-.032-.223-.034-.22-.036-.217-.038-.214-.04-.211-.041-.208-.043-.204-.045-.201-.046-.198-.048-.195-.05-.19-.051-.187-.053-.184-.054-.179-.056-.176-.057-.172-.059-.167-.06-.164-.061-.159-.063-.155-.064-.151-.066-.074-.033-.072-.033-.072-.034-.07-.034-.069-.035-.068-.035-.067-.035-.066-.035-.064-.036-.063-.036-.062-.036-.061-.036-.06-.037-.058-.037-.057-.037-.056-.038-.055-.038-.053-.038-.052-.038-.051-.039-.049-.039-.049-.039-.046-.039-.046-.04-.044-.04-.043-.04-.041-.04-.04-.041-.039-.041-.037-.041-.036-.041-.034-.041-.033-.042-.032-.042-.03-.042-.029-.042-.027-.042-.026-.043-.024-.043-.023-.043-.021-.043-.02-.043-.018-.044-.017-.043-.015-.044-.013-.044-.012-.044-.011-.045-.009-.044-.007-.045-.006-.045-.004-.045-.002-.045-.001-.045v-17l.001-.045.002-.045.004-.045.006-.045.007-.045.009-.044.011-.045.012-.044.013-.044.015-.044.017-.043.018-.044.02-.043.021-.043.023-.043.024-.043.026-.043.027-.042.029-.042.03-.042.032-.042.033-.042.034-.041.036-.041.037-.041.039-.041.04-.041.041-.04.043-.04.044-.04.046-.04.046-.039.049-.039.049-.039.051-.039.052-.038.053-.038.055-.038.056-.038.057-.037.058-.037.06-.037.061-.036.062-.036.063-.036.064-.036.066-.035.067-.035.068-.035.069-.035.07-.034.072-.034.072-.033.074-.033.151-.066.155-.064.159-.063.164-.061.167-.06.172-.059.176-.057.179-.056.184-.054.187-.053.19-.051.195-.05.198-.048.201-.046.204-.045.208-.043.211-.041.214-.04.217-.038.22-.036.223-.034.226-.032.228-.031.231-.028.234-.027.236-.024.238-.023.241-.02.243-.019.245-.016.247-.015.249-.012.251-.01.253-.008.255-.005.256-.004.258-.001.258.001zm-9.258 20.499v.01l.001.021.003.021.004.022.005.021.006.022.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.023.018.024.019.024.021.024.022.025.023.024.024.025.052.049.056.05.061.051.066.051.07.051.075.051.079.052.084.052.088.052.092.052.097.052.102.051.105.052.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.048.144.049.147.047.152.047.155.047.16.045.163.045.167.043.171.043.176.041.178.041.183.039.187.039.19.037.194.035.197.035.202.033.204.031.209.03.212.029.216.027.219.025.222.024.226.021.23.02.233.018.236.016.24.015.243.012.246.01.249.008.253.005.256.004.259.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.021.224-.024.22-.026.216-.027.212-.028.21-.031.205-.031.202-.034.198-.034.194-.036.191-.037.187-.039.183-.04.179-.04.175-.042.172-.043.168-.044.163-.045.16-.046.155-.046.152-.047.148-.048.143-.049.139-.049.136-.05.131-.05.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.053.083-.051.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.05.023-.024.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.023.01-.022.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.127l-.077.055-.08.053-.083.054-.085.053-.087.052-.09.052-.093.051-.095.05-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.045-.118.044-.12.043-.122.042-.124.042-.126.041-.128.04-.13.04-.132.038-.134.038-.135.037-.138.037-.139.035-.142.035-.143.034-.144.033-.147.032-.148.031-.15.03-.151.03-.153.029-.154.027-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.01-.179.008-.179.008-.181.006-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.006-.179-.008-.179-.008-.178-.01-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.027-.153-.029-.151-.03-.15-.03-.148-.031-.146-.032-.145-.033-.143-.034-.141-.035-.14-.035-.137-.037-.136-.037-.134-.038-.132-.038-.13-.04-.128-.04-.126-.041-.124-.042-.122-.042-.12-.044-.117-.043-.116-.045-.113-.045-.112-.046-.109-.047-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.05-.093-.052-.09-.051-.087-.052-.085-.053-.083-.054-.08-.054-.077-.054v4.127zm0-5.654v.011l.001.021.003.021.004.021.005.022.006.022.007.022.009.022.01.022.011.023.012.023.013.023.015.024.016.023.017.024.018.024.019.024.021.024.022.024.023.025.024.024.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.052.11.051.114.051.119.052.123.05.127.051.131.05.135.049.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.044.171.042.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.022.23.02.233.018.236.016.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.012.241-.015.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.048.139-.05.136-.049.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.051.051-.049.023-.025.023-.024.021-.025.02-.024.019-.024.018-.024.017-.024.015-.023.014-.023.013-.024.012-.022.01-.023.01-.023.008-.022.006-.022.006-.022.004-.021.004-.022.001-.021.001-.021v-4.139l-.077.054-.08.054-.083.054-.085.052-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.049-.105.048-.106.047-.109.047-.111.046-.114.045-.115.044-.118.044-.12.044-.122.042-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.035-.143.033-.144.033-.147.033-.148.031-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.025-.161.024-.162.023-.163.022-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.011-.178.009-.179.009-.179.007-.181.007-.182.005-.182.004-.184.003-.184.002h-.37l-.184-.002-.184-.003-.182-.004-.182-.005-.181-.007-.179-.007-.179-.009-.178-.009-.176-.011-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.022-.162-.023-.161-.024-.159-.025-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.031-.146-.033-.145-.033-.143-.033-.141-.035-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.04-.126-.041-.124-.042-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.047-.105-.048-.102-.049-.1-.049-.097-.05-.095-.051-.093-.051-.09-.051-.087-.053-.085-.052-.083-.054-.08-.054-.077-.054v4.139zm0-5.666v.011l.001.02.003.022.004.021.005.022.006.021.007.022.009.023.01.022.011.023.012.023.013.023.015.023.016.024.017.024.018.023.019.024.021.025.022.024.023.024.024.025.052.05.056.05.061.05.066.051.07.051.075.052.079.051.084.052.088.052.092.052.097.052.102.052.105.051.11.052.114.051.119.051.123.051.127.05.131.05.135.05.139.049.144.048.147.048.152.047.155.046.16.045.163.045.167.043.171.043.176.042.178.04.183.04.187.038.19.037.194.036.197.034.202.033.204.032.209.03.212.028.216.027.219.025.222.024.226.021.23.02.233.018.236.017.24.014.243.012.246.01.249.008.253.006.256.003.259.001.26-.001.257-.003.254-.006.25-.008.247-.01.244-.013.241-.014.237-.016.233-.018.231-.02.226-.022.224-.024.22-.025.216-.027.212-.029.21-.03.205-.032.202-.033.198-.035.194-.036.191-.037.187-.039.183-.039.179-.041.175-.042.172-.043.168-.044.163-.045.16-.045.155-.047.152-.047.148-.048.143-.049.139-.049.136-.049.131-.051.126-.05.123-.051.118-.052.114-.051.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.052.07-.051.065-.051.06-.051.056-.05.051-.049.023-.025.023-.025.021-.024.02-.024.019-.024.018-.024.017-.024.015-.023.014-.024.013-.023.012-.023.01-.022.01-.023.008-.022.006-.022.006-.022.004-.022.004-.021.001-.021.001-.021v-4.153l-.077.054-.08.054-.083.053-.085.053-.087.053-.09.051-.093.051-.095.051-.097.05-.1.049-.102.048-.105.048-.106.048-.109.046-.111.046-.114.046-.115.044-.118.044-.12.043-.122.043-.124.042-.126.041-.128.04-.13.039-.132.039-.134.038-.135.037-.138.036-.139.036-.142.034-.143.034-.144.033-.147.032-.148.032-.15.03-.151.03-.153.028-.154.028-.156.027-.158.026-.159.024-.161.024-.162.023-.163.023-.165.021-.166.02-.167.019-.169.018-.169.017-.171.016-.173.015-.173.014-.175.013-.175.012-.177.01-.178.01-.179.009-.179.007-.181.006-.182.006-.182.004-.184.003-.184.001-.185.001-.185-.001-.184-.001-.184-.003-.182-.004-.182-.006-.181-.006-.179-.007-.179-.009-.178-.01-.176-.01-.176-.012-.175-.013-.173-.014-.172-.015-.171-.016-.17-.017-.169-.018-.167-.019-.166-.02-.165-.021-.163-.023-.162-.023-.161-.024-.159-.024-.157-.026-.156-.027-.155-.028-.153-.028-.151-.03-.15-.03-.148-.032-.146-.032-.145-.033-.143-.034-.141-.034-.14-.036-.137-.036-.136-.037-.134-.038-.132-.039-.13-.039-.128-.041-.126-.041-.124-.041-.122-.043-.12-.043-.117-.044-.116-.044-.113-.046-.112-.046-.109-.046-.106-.048-.105-.048-.102-.048-.1-.05-.097-.049-.095-.051-.093-.051-.09-.052-.087-.052-.085-.053-.083-.053-.08-.054-.077-.054v4.153zm8.74-8.179l-.257.004-.254.005-.25.008-.247.011-.244.012-.241.014-.237.016-.233.018-.231.021-.226.022-.224.023-.22.026-.216.027-.212.028-.21.031-.205.032-.202.033-.198.034-.194.036-.191.038-.187.038-.183.04-.179.041-.175.042-.172.043-.168.043-.163.045-.16.046-.155.046-.152.048-.148.048-.143.048-.139.049-.136.05-.131.05-.126.051-.123.051-.118.051-.114.052-.11.052-.106.052-.101.052-.096.052-.092.052-.088.052-.083.052-.079.052-.074.051-.07.052-.065.051-.06.05-.056.05-.051.05-.023.025-.023.024-.021.024-.02.025-.019.024-.018.024-.017.023-.015.024-.014.023-.013.023-.012.023-.01.023-.01.022-.008.022-.006.023-.006.021-.004.022-.004.021-.001.021-.001.021.001.021.001.021.004.021.004.022.006.021.006.023.008.022.01.022.01.023.012.023.013.023.014.023.015.024.017.023.018.024.019.024.02.025.021.024.023.024.023.025.051.05.056.05.06.05.065.051.07.052.074.051.079.052.083.052.088.052.092.052.096.052.101.052.106.052.11.052.114.052.118.051.123.051.126.051.131.05.136.05.139.049.143.048.148.048.152.048.155.046.16.046.163.045.168.043.172.043.175.042.179.041.183.04.187.038.191.038.194.036.198.034.202.033.205.032.21.031.212.028.216.027.22.026.224.023.226.022.231.021.233.018.237.016.241.014.244.012.247.011.25.008.254.005.257.004.26.001.26-.001.257-.004.254-.005.25-.008.247-.011.244-.012.241-.014.237-.016.233-.018.231-.021.226-.022.224-.023.22-.026.216-.027.212-.028.21-.031.205-.032.202-.033.198-.034.194-.036.191-.038.187-.038.183-.04.179-.041.175-.042.172-.043.168-.043.163-.045.16-.046.155-.046.152-.048.148-.048.143-.048.139-.049.136-.05.131-.05.126-.051.123-.051.118-.051.114-.052.11-.052.106-.052.101-.052.096-.052.092-.052.088-.052.083-.052.079-.052.074-.051.07-.052.065-.051.06-.05.056-.05.051-.05.023-.025.023-.024.021-.024.02-.025.019-.024.018-.024.017-.023.015-.024.014-.023.013-.023.012-.023.01-.023.01-.022.008-.022.006-.023.006-.021.004-.022.004-.021.001-.021.001-.021-.001-.021-.001-.021-.004-.021-.004-.022-.006-.021-.006-.023-.008-.022-.01-.022-.01-.023-.012-.023-.013-.023-.014-.023-.015-.024-.017-.023-.018-.024-.019-.024-.02-.025-.021-.024-.023-.024-.023-.025-.051-.05-.056-.05-.06-.05-.065-.051-.07-.052-.074-.051-.079-.052-.083-.052-.088-.052-.092-.052-.096-.052-.101-.052-.106-.052-.11-.052-.114-.052-.118-.051-.123-.051-.126-.051-.131-.05-.136-.05-.139-.049-.143-.048-.148-.048-.152-.048-.155-.046-.16-.046-.163-.045-.168-.043-.172-.043-.175-.042-.179-.041-.183-.04-.187-.038-.191-.038-.194-.036-.198-.034-.202-.033-.205-.032-.21-.031-.212-.028-.216-.027-.22-.026-.224-.023-.226-.022-.231-.021-.233-.018-.237-.016-.241-.014-.244-.012-.247-.011-.25-.008-.254-.005-.257-.004-.26-.001-.26.001z\"></path></symbol></defs><defs><symbol id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-clock\" width=\"24\" height=\"24\"><path transform=\"scale(.5)\" d=\"M12 2c5.514 0 10 4.486 10 10s-4.486 10-10 10-10-4.486-10-10 4.486-10 10-10zm0-2c-6.627 0-12 5.373-12 12s5.373 12 12 12 12-5.373 12-12-5.373-12-12-12zm5.848 12.459c.202.038.202.333.001.372-1.907.361-6.045 1.111-6.547 1.111-.719 0-1.301-.582-1.301-1.301 0-.512.77-5.447 1.125-7.445.034-.192.312-.181.343.014l.985 6.238 5.394 1.011z\"></path></symbol></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead\" refX=\"7.9\" refY=\"5\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M -1 0 L 10 5 L 0 10 z\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-crosshead\" markerWidth=\"15\" markerHeight=\"8\" orient=\"auto\" refX=\"4\" refY=\"4.5\"><path fill=\"none\" stroke=\"#000000\" stroke-width=\"1pt\" d=\"M 1,2 L 6,7 M 6,2 L 1,7\" style=\"stroke-dasharray: 0, 0;\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-filled-head\" refX=\"15.5\" refY=\"7\" markerWidth=\"20\" markerHeight=\"28\" orient=\"auto\"><path d=\"M 18,7 L9,13 L14,7 L9,1 Z\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-sequencenumber\" refX=\"15\" refY=\"15\" markerWidth=\"60\" markerHeight=\"40\" orient=\"auto\"><circle cx=\"15\" cy=\"15\" r=\"6\"></circle></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-solidTopArrowHead\" refX=\"7.9\" refY=\"7.25\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 10 8 L 0 8 z\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-solidBottomArrowHead\" refX=\"7.9\" refY=\"0.75\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 10 0 L 0 8 z\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-stickTopArrowHead\" refX=\"7.5\" refY=\"7\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 0 L 7 7\" stroke=\"black\" stroke-width=\"1.5\" fill=\"none\"></path></marker></defs><defs><marker id=\"diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-stickBottomArrowHead\" refX=\"7.5\" refY=\"0\" markerUnits=\"userSpaceOnUse\" markerWidth=\"12\" markerHeight=\"12\" orient=\"auto-start-reverse\"><path d=\"M 0 7 L 7 0\" stroke=\"black\" stroke-width=\"1.5\" fill=\"none\"></path></marker></defs><g data-et=\"control-structure\" data-id=\"i9\"><line x1=\"64\" y1=\"347\" x2=\"350\" y2=\"347\" class=\"loopLine\"></line><line x1=\"350\" y1=\"347\" x2=\"350\" y2=\"482\" class=\"loopLine\"></line><line x1=\"64\" y1=\"482\" x2=\"350\" y2=\"482\" class=\"loopLine\"></line><line x1=\"64\" y1=\"347\" x2=\"64\" y2=\"482\" class=\"loopLine\"></line><polygon points=\"64,347 114,347 114,360 105.6,367 64,367\" class=\"labelBox\"></polygon><text x=\"89\" y=\"360\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"labelText\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">loop</text><text x=\"232\" y=\"365\" text-anchor=\"middle\" class=\"loopText\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\"><tspan x=\"232\">[Until terminal status]</tspan></text></g><text x=\"206\" y=\"80\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">1. Request pre-signed URL</text><line x1=\"76\" y1=\"111\" x2=\"335\" y2=\"111\" class=\"messageLine0\" data-et=\"message\" data-id=\"i0\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"126\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">presignedUrl</text><line x1=\"338\" y1=\"157\" x2=\"79\" y2=\"157\" class=\"messageLine1\" data-et=\"message\" data-id=\"i1\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"306\" y=\"172\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">2. PUT file bytes</text><line x1=\"76\" y1=\"203\" x2=\"536.5\" y2=\"203\" class=\"messageLine0\" data-et=\"message\" data-id=\"i2\" data-from=\"Client\" data-to=\"Storage\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"fill: none;\"></line><text x=\"309\" y=\"218\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">2xx</text><line x1=\"539.5\" y1=\"247\" x2=\"79\" y2=\"247\" class=\"messageLine1\" data-et=\"message\" data-id=\"i3\" data-from=\"Storage\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"206\" y=\"262\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">3. Register object URL</text><line x1=\"76\" y1=\"293\" x2=\"335\" y2=\"293\" class=\"messageLine0\" data-et=\"message\" data-id=\"i4\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"308\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">fileId, status=0</text><line x1=\"338\" y1=\"337\" x2=\"79\" y2=\"337\" class=\"messageLine1\" data-et=\"message\" data-id=\"i5\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"206\" y=\"397\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">4. Query upload result</text><line x1=\"76\" y1=\"428\" x2=\"335\" y2=\"428\" class=\"messageLine0\" data-et=\"message\" data-id=\"i7\" data-from=\"Client\" data-to=\"API\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"fill: none;\"></line><text x=\"209\" y=\"443\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">null / status 0, 1, or 2</text><line x1=\"338\" y1=\"472\" x2=\"79\" y2=\"472\" class=\"messageLine1\" data-et=\"message\" data-id=\"i8\" data-from=\"API\" data-to=\"Client\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"stroke-dasharray: 3, 3; fill: none;\"></line><text x=\"539\" y=\"497\" text-anchor=\"middle\" dominant-baseline=\"middle\" alignment-baseline=\"middle\" class=\"messageText\" dy=\"1em\" style=\"font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif; font-size: 16px; font-weight: 400;\">Deliver file</text><line x1=\"340\" y1=\"526\" x2=\"738\" y2=\"526\" class=\"messageLine0\" data-et=\"message\" data-id=\"i10\" data-from=\"API\" data-to=\"Phone\" stroke-width=\"2\" stroke=\"none\" marker-end=\"url(#diagram-16f97452fe3f4866ca53d3b1f7f5172dcd29b68176d06079fbf554c8f966aa3e-arrowhead)\" style=\"fill: none;\"></line></svg>"},"children":["sequenceDiagram\n    participant Client\n    participant API as MoreLogin API\n    participant Storage as Temporary storage\n    participant Phone as Cloud Phone\n    Client->>API: 1. Request pre-signed URL\n    API-->>Client: presignedUrl\n    Client->>Storage: 2. PUT file bytes\n    Storage-->>Client: 2xx\n    Client->>API: 3. Register object URL\n    API-->>Client: fileId, status=0\n    loop Until terminal status\n        Client->>API: 4. Query upload result\n        API-->>Client: null / status 0, 1, or 2\n    end\n    API->>Phone: Deliver file\n"]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":3,"id":"1-request-a-pre-signed-url","__idx":4},"children":["1. Request a pre-signed URL"]},{"$$mdtype":"Tag","name":"CodeBlock","attributes":{"data-language":"bash","header":{"controls":{"copy":{}}},"source":"curl --request POST \"https://api.morelogin.com/cloudphone/uploadUrl\" \\\n  --header \"Authorization: Bearer $MORELOGIN_TOKEN\" \\\n  --header \"Content-Type: application/json\" \\\n  --data '{\n    \"id\": \"1661515884160372\",\n    \"fileName\": \"report.csv\"\n  }'\n","lang":"bash"},"children":[]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["The response contains ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["data.presignedUrl"]},". The temporary object is automatically deleted after 7 days; this does not delete a file that has already been delivered to the Cloud Phone."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":3,"id":"2-upload-the-file-bytes","__idx":5},"children":["2. Upload the file bytes"]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Send the file directly to the returned URL. Do not add the MoreLogin Bearer token to this storage request."]},{"$$mdtype":"Tag","name":"CodeBlock","attributes":{"data-language":"bash","header":{"controls":{"copy":{}}},"source":"curl --location --request PUT \\\n  --upload-file \"./report.csv\" \\\n  \"$PRESIGNED_URL\"\n","lang":"bash"},"children":[]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Only continue after the storage service returns a successful HTTP status. If this request fails or times out, retry the ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["PUT"]}," to the same URL while it remains valid."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":3,"id":"3-register-the-object-for-delivery","__idx":6},"children":["3. Register the object for delivery"]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Use the uploaded object URL. The query string on a pre-signed URL contains credentials, so remove it before storing or logging the URL when your object-store configuration permits it."]},{"$$mdtype":"Tag","name":"CodeBlock","attributes":{"data-language":"bash","header":{"controls":{"copy":{}}},"source":"FILE_URL=\"${PRESIGNED_URL%%\\?*}\"\n\ncurl --request POST \"https://api.morelogin.com/cloudphone/uploadFile\" \\\n  --header \"Authorization: Bearer $MORELOGIN_TOKEN\" \\\n  --header \"Content-Type: application/json\" \\\n  --data \"$(jq -n \\\n    --arg id '1661515884160372' \\\n    --arg url \"$FILE_URL\" \\\n    --arg dest '/Download' \\\n    '{id: $id, url: $url, uploadDest: $dest, uploadType: 1}')\"\n","lang":"bash"},"children":[]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Use ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["uploadType: 1"]}," for regular files. Use ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["uploadType: 2"]}," only for supported MP4 live-streaming files. Save ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["data.fileId"]}," from the response."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":3,"id":"4-poll-the-upload-result","__idx":7},"children":["4. Poll the upload result"]},{"$$mdtype":"Tag","name":"CodeBlock","attributes":{"data-language":"bash","header":{"controls":{"copy":{}}},"source":"curl --request POST \"https://api.morelogin.com/cloudphone/uploadFileResult\" \\\n  --header \"Authorization: Bearer $MORELOGIN_TOKEN\" \\\n  --header \"Content-Type: application/json\" \\\n  --data '{\n    \"id\": \"1661515884160372\",\n    \"fileId\": \"1661515884160111\"\n  }'\n","lang":"bash"},"children":[]},{"$$mdtype":"Tag","name":"div","attributes":{"className":"md-table-wrapper"},"children":[{"$$mdtype":"Tag","name":"table","attributes":{"className":"md"},"children":[{"$$mdtype":"Tag","name":"thead","attributes":{},"children":[{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"data / data.status"},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["data"]}," / ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["data.status"]}]},{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"Meaning"},"children":["Meaning"]},{"$$mdtype":"Tag","name":"th","attributes":{"data-label":"Action"},"children":["Action"]}]}]},{"$$mdtype":"Tag","name":"tbody","attributes":{},"children":[{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["null"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["The task is not visible yet"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Wait and poll again"]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["0"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Uploading"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Wait and poll again"]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["1"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Successful"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Stop polling"]}]},{"$$mdtype":"Tag","name":"tr","attributes":{},"children":[{"$$mdtype":"Tag","name":"td","attributes":{},"children":[{"$$mdtype":"Tag","name":"code","attributes":{},"children":["2"]}]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Failed"]},{"$$mdtype":"Tag","name":"td","attributes":{},"children":["Stop polling and report ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["requestId"]}]}]}]}]}]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["Poll every 2 seconds and set a client-side deadline appropriate for the file size. Do not create another upload task merely because a status request timed out; query the existing ",{"$$mdtype":"Tag","name":"code","attributes":{},"children":["fileId"]}," first."]},{"$$mdtype":"Tag","name":"Heading","attributes":{"level":2,"id":"download-workflow","__idx":8},"children":["Download workflow"]},{"$$mdtype":"Tag","name":"p","attributes":{},"children":["“Download” is an export from the Cloud Phone to a temporary URL. It is a two-stage asynchronous workflow."]},{"$$mdtype":"Tag","name":"Diagram","attributes":{"data-language":"mermaid","diagramType":"mermaid","diagramSource":"sequenceDiagram\n    participant Client\n    participant API as MoreLogin API\n    participant Phone as Cloud Phone\n    participant Storage as Temporary storage\n    Client->>API: 1. Request file export (id, filePath)\n    API->>Phone: Read and export file\n    API-->>Client: downId\n    loop While status=10\n        Client->>API: 2. Query export result (id, downId)\n        API-->>Client: status=10\n    end\n    Phone->>Storage: Write exported file\n    API-->>Client: status=20, downUrl\n    Client->>Storage: 3. GET downUrl\n    Storage-->>Client: File bytes\n","diagramHtml":"<svg id=\"diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64\" width=\"100%\" xmlns=\"http://www.w3.org/2000/svg\" style=\"max-width: 978px;\" viewBox=\"-50 -10 978 632\" role=\"graphics-document document\" aria-roledescription=\"sequence\"><style>\n    #diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 foreignObject {\n      overflow: visible;\n    }\n  </style><g><rect x=\"725\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"801.5\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"801.5\" dy=\"0\">Temporary storage</tspan></text></g><g><rect x=\"525\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"600\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"600\" dy=\"0\">Cloud Phone</tspan></text></g><g><rect x=\"312\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"387\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"387\" dy=\"0\">MoreLogin API</tspan></text></g><g><rect x=\"0\" y=\"546\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-bottom\"></rect><text x=\"75\" y=\"578.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g><g><line id=\"actor3\" x1=\"801.5\" y1=\"65\" x2=\"801.5\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Storage\" data-et=\"life-line\" data-id=\"Storage\"></line><g id=\"root-3\" data-et=\"participant\" data-type=\"participant\" data-id=\"Storage\"><rect x=\"725\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"153\" height=\"65\" name=\"Storage\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"801.5\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"801.5\" dy=\"0\">Temporary storage</tspan></text></g></g><g><line id=\"actor2\" x1=\"600\" y1=\"65\" x2=\"600\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Phone\" data-et=\"life-line\" data-id=\"Phone\"></line><g id=\"root-2\" data-et=\"participant\" data-type=\"participant\" data-id=\"Phone\"><rect x=\"525\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Phone\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"600\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"600\" dy=\"0\">Cloud Phone</tspan></text></g></g><g><line id=\"actor1\" x1=\"387\" y1=\"65\" x2=\"387\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"API\" data-et=\"life-line\" data-id=\"API\"></line><g id=\"root-1\" data-et=\"participant\" data-type=\"participant\" data-id=\"API\"><rect x=\"312\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"API\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"387\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"387\" dy=\"0\">MoreLogin API</tspan></text></g></g><g><line id=\"actor0\" x1=\"75\" y1=\"65\" x2=\"75\" y2=\"546\" class=\"actor-line 200\" stroke-width=\"0.5px\" stroke=\"#999\" name=\"Client\" data-et=\"life-line\" data-id=\"Client\"></line><g id=\"root-0\" data-et=\"participant\" data-type=\"participant\" data-id=\"Client\"><rect x=\"0\" y=\"0\" fill=\"#eaeaea\" stroke=\"#666\" width=\"150\" height=\"65\" name=\"Client\" rx=\"3\" ry=\"3\" class=\"actor actor-top\"></rect><text x=\"75\" y=\"32.5\" dominant-baseline=\"central\" alignment-baseline=\"central\" class=\"actor actor-box\" style=\"text-anchor: middle; font-size: 16px; font-weight: 400; font-family: &quot;Redocly Mermaid Sans&quot;, Arial, &quot;Liberation Sans&quot;, Arimo, Helvetica, &quot;Redocly Mermaid CJK&quot;, sans-serif;\"><tspan x=\"75\" dy=\"0\">Client</tspan></text></g></g><style>#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;fill:#333;}@keyframes edge-animation-frame{from{stroke-dashoffset:0;}}@keyframes dash{to{stroke-dashoffset:0;}}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-animation-slow{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 50s linear infinite;stroke-linecap:round;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-animation-fast{stroke-dasharray:9,5!important;stroke-dashoffset:900;animation:dash 20s linear infinite;stroke-linecap:round;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .error-icon{fill:#552222;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .error-text{fill:#552222;stroke:#552222;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-thickness-normal{stroke-width:1px;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-thickness-thick{stroke-width:3.5px;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-pattern-solid{stroke-dasharray:0;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-thickness-invisible{stroke-width:0;fill:none;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-pattern-dashed{stroke-dasharray:3;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .edge-pattern-dotted{stroke-dasharray:2;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .marker{fill:#333333;stroke:#333333;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .marker.cross{stroke:#333333;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 svg{font-family:\"Redocly Mermaid Sans\",Arial,\"Liberation Sans\",Arimo,Helvetica,\"Redocly Mermaid CJK\",sans-serif;font-size:16px;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 p{margin:0;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .actor{stroke:#9370DB;fill:#ECECFF;stroke-width:1;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 rect.actor.outer-path[data-look=\"neo\"]{filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 rect.note[data-look=\"neo\"]{stroke:#aaaa33;fill:#fff5ad;filter:drop-shadow(1px 2px 2px rgba(185, 185, 185, 1));}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 text.actor&gt;tspan{fill:black;stroke:none;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .actor-line{stroke:#9370DB;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .innerArc{stroke-width:1.5;stroke-dasharray:none;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .messageLine0{stroke-width:1.5;stroke-dasharray:none;stroke:#333;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .messageLine1{stroke-width:1.5;stroke-dasharray:2,2;stroke:#333;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 [id$=\"-arrowhead\"] path{fill:#333;stroke:#333;}#diagram-fb85c7a9861600f7698fe48d0897ac241867d755f16c2e7aacc5478fac94ad64 .sequ
[...]
